/* $Header:hc.h 12.0$ */
/* $ACIS:hc.h 12.0$ */
/* $Source: /ibm/acis/usr/src/bin/RCS/hc.h,v $ */

#if !defined(lint) && !defined(LOCORE) && defined(RCS_HDRS)
static char *rcsidhc = "$Header:hc.h 12.0$";
#endif

/* * This file is used to tailor the nhc command
 *
 * Set the symbol HCDIR to the pathname of the directory in which the
 * High C distribution was distributed. Suffix the string with "/".
 *
 */
#define RT
#define IBM

/*
 * INCLUDE_DIR1 and INCLUDE_DIR2 are the "standard" directories to be
 * searched for include files.
 *
 * INCLUDE_DIR2 must always be defined, INCLUDE_DIR1 need not be defined 
 * if there is only a single "standard" place for include processing.
 */


#  ifndef HCDIR
#      define HCDIR "/usr/lib/"
#  endif
#  ifndef TOOLSDIR
#      define TOOLSDIR "/u/29k/bin/"
#  endif
#  ifndef HC1COM
#    define HC1COM HCDIR "hc1com"   /*First pass of High C*/
#  endif
/* #  define INCLUDE_DIR1 HCDIR "inc"	  ANSI includes*/
#  define INCLUDE_DIR2 "/usr/include"	/*Standard include directory*/
  /*
   * Define pathnames of ANSI parse and scan tables
   */
#  define HCANSIST  HCDIR "hc/hcansi.st"  /*ANSI C Scan tables*/
#  define HCANSIPT  HCDIR "hc/hcansi.pt"  /*ANSI C Parse tables*/
#  define HCANSIPPT HCDIR "hc/hcansip.pt" /*ANSI C preprocessor table*/

#ifdef RT
#   ifndef HC2COM
#     define HC2COM HCDIR "hc2com"   /*2nd pass of High C*/
#   endif
#   ifndef IBM
#      define LIB1 HCDIR "libc.a"   /*ANSI library*/
#      define MLIB HCDIR "libm.a"   /*ANSI floating point library*/
#   endif
/* #   define MWLIB HCDIR "libmw.a"     Floating point library*/
#   define TARGET_MACHINE_NAME "rtfl"
#   define FPLIB_P "-lfp_p"		/*fpgen must be profiled too*/
#   define LDARG1 "-X"
#   define DEFINE_STRING "ibm032 1"
/* #   define ASMFLAG1 "-strict"	Disable, until lda works right*/
#   define ASMFLAG2 "-V"		/*Big savings on sys time*/
#endif

#define XREF  HCDIR "xref"	/*Pathname of xref processor*/
#define HC  "hc"	/*Name of command that invokes compiler, used
			   by cross-referencer facility*/

/*
 * Default settings for alterable toggles. See chapter 4 in the
 * Programmer's Guide for details.
 */

#define CHAR_DEFAULT_UNSIGNED	ON	/*Set to OFF if "char" is signed*/
#define DOUBLE_MATH_ONLY	OFF	
#define DOUBLE_RETURN		OFF
#define	LONG_ENUMS		OFF
#define	PCC			OFF	/*Set to ON for PCC compatibility*/
#define	PCC_MSGS		OFF

/*
 * The compiler issues a number of warnings that the Portable C Compiler
 * does not (e.g., "function not declared"). If these extra warnings are
 * to be suppressed then set symbol PCC_MSGS above to ON
 * The "+w" flag will turn on all warnings regardless of how this symbol is set.
 */

#define CPP_ONLY 0	/*If 1 then cpp is unconditionally used*/
#if !CPP_ONLY
#define USE_CPP_FOR_HC_BY_DEFAULT FALSE	/*Do we invoke cpp for C programs? */
#define USE_CPP_FOR_PP_BY_DEFAULT FALSE	/*Do we invoke cpp for C programs? */
#endif

#ifdef IBM
#    undef DOUBLE_RETURN
#    undef LONG_ENUMS
#    undef PCC_MSGS
#    undef USE_CPP_FOR_HC_BY_DEFAULT
#    define DOUBLE_RETURN	ON
#    define LONG_ENUMS		ON
#    define PCC_MSGS		ON
#    define USE_CPP_FOR_HC_BY_DEFAULT TRUE /*invoke cpp for C programs */
#endif


#				ifndef LD
#define LD "/bin/ld"	/*Name of linker (if any) */
#				endif
#				ifndef AS
#define AS "/bin/as"	/*Name of assembler (if any) */
#				endif
#define OBJ_SUFFIX "o"	/*Suffix of object modules*/
#				ifndef CLIB
#define CLIB "-lc"		/*Name of C library (as specified to ld)*/
#define CLIB_P "-lc_p"	/*Name of profiled C library (if available)*/
#				endif
#				ifndef CSTART
#define CSTART "/lib/crt0.o"           	/*Name of C startup routine*/
#				endif
#define GPROFSTART "/usr/lib/gcrt0.o"	/*Startup routine for -pg */
#define PROFSTART "/lib/mcrt0.o"		/*Startup routine for -p */
#define HCPRO "hc.pro"
