#
# 5799-WZQ (C) COPYRIGHT = NONE
# LICENSED MATERIALS - PROPERTY OF IBM
#
# $Header:main.mc 12.0$ 
# $ACIS:main.mc 12.0$ 
# $Source: /ibm/acis/usr/src/usr.lib/sendmail/cf.yp/RCS/main.mc,v $ 
# @(#)main.mc	1.1 87/09/08 3.2/4.3NFSSRC
############################################################
#
#	Sendmail configuration file for "MAIN MACHINES"
#
#	You should install this file as /etc/sendmail.cf
#	if your machine is the main (or only) mail-relaying
#	machine in your domain.  Then edit the file to
#	customize it for your network configuration.
#
#	See the manual "System and Network Administration for the Sun
#	Workstation". Look at "Setting Up The Mail Routing System" in
#	the chapter on Communications.  The Sendmail reference in the
#	back of the manual is also useful.
#
#	@(#)main.mc 1.13 87/09/04 SMI
#

###	local info

# my official hostname
# You have two choices here.  If you want the gateway machine to identify
# itself as the DOMAIN, use this line:
Dj$m
# If you want the gateway machine to appear to be INSIDE the domain, use:
#Dj$w.$m
# Unless you are using sendmail.mx (or have a fully-qualified hostname), use:
#Dj$w

# major relay mailer - typical choice is "ddn" if you are on the
# Defense Data Network (e.g. Arpanet or Milnet)
DMuucp

# major relay host: use the $M mailer to send mail to other domains
ifdef(`m4GATEWAY',, `define(m4GATEWAY,ddn-gateway)')dnl
DR m4GATEWAY
CR m4GATEWAY

# If you want to pre-load the "mailhosts" then use a line like
# FS /usr/lib/mailhosts
# and then change all the occurences of $%y to be $=S instead.
# Otherwise, the default is to use the hosts.byname map if YP
# is running (or else the /etc/hosts file if no YP).

# valid top-level domains
CT arpa com edu gov org net mil

# options that you probably want on a mailhost:

# checkpoint the queue after this many receipients
OC10

# refuse to send tiny messages to more than these recipients
Ob10

include(sunbase.m4)

include(uucpm.m4)

include(ddnm.m4)

############################################################
#
#		RULESET ZERO
#
#	This is the ruleset that determines which mailer a name goes to.

# Ruleset 30 just calls rulesets 3 then 0.
S30
R$*			$: $>3 $1			First canonicalize
R$*			$@ $>0 $1			Then rerun ruleset 0

S0
# On entry, the address has been canonicalized and focused by ruleset 3.
# Handle special cases.....
R@			$#local $:$n			handle <> form
# For numeric spec, you can't pass spec on to receiver, since rcvr's
# are not smart enough to know that [x.y.z.a] is their own name.
R<@[$+]>:$*		$:$>9 <@[$1]>:$2		Clean it up, then...
R<@[$+]>:$*		$#ether $@[$1] $:$2		numeric internet spec
R<@[$+]>,$*		$#ether $@[$1] $:$2		numeric internet spec
R$*<@[$+]>		$#ether $@[$2] $:$1		numeric internet spec

# resolve the local hostname to "LOCAL".
R$*<$*$=w.LOCAL>$*	$1<$2LOCAL>$4			thishost.LOCAL
R$*<$*$=w.uucp>$*	$1<$2LOCAL>$4			thishost.uucp
R$*<$*$=w>$*		$1<$2LOCAL>$4			thishost

# Mail addressed explicitly to the domain gateway (us)
R$*<@LOCAL>		$@$>30$1			strip our name, retry
R<@LOCAL>:$+		$@$>30$1			retry after route strip

# deliver to known ethernet hosts explicitly specified in our domain
R$*<@$%y.LOCAL>$*	$#ether $@$2 $:$1<@$2>$3	user@host.sun.com

# etherhost.uucp is treated as etherhost.$m for now.
# This allows them to be addressed from uucp as foo!sun!etherhost!user.
R$*<@$%y.uucp>$*	$#ether $@$2 $:$1<@$2>$3	user@etherhost.uucp

# Explicitly specified names in our domain -- that we've never heard of
R$*<@$*.LOCAL>$*	$#error $:Never heard of host $2 in domain $m

# Clean up addresses for external use -- kills LOCAL, route-addr ,=>: 
R$*			$:$>9 $1			Then continue...

# resolve UUCP domain
R<@$-.uucp>:$+		$#uucp  $@$1 $:$2		@host.uucp:...
R$+<@$-.uucp>		$#uucp  $@$2 $:$1		user@host.uucp

# Pass Arpanet and Bitnet names up the ladder to our forwarder
R$*<@$*.$=T>$*		$#$M    $@$R $:$1<@$2.$3>$4	user@any.domain

# if you are on the DDN, then comment-out the line above and use the
# following instead:
#R$*<@$*.$+>$*		$#ddn $@ $2.$3 $:$1<@$2.$3>$4	user@any.domain

# All addresses in the rules ABOVE are absolute (fully qualified domains).
# Addresses BELOW can be partially qualified.

# deliver to known ethernet hosts
R$*<@$%y>$*		$#ether $@$2 $:$1<@$2>$3	user@etherhost

# other non-local names have nowhere to go; return them to sender.
R$*<@$+.$->$*		$#error $:Unknown domain $3
R$*<@$+>$*		$#error $:Never heard of $2 in domain $m
R$*@$*			$#error $:I don't understand $1@$2

# Local names with % are really not local!
R$+%$+			$@$>30$1@$2			turn % => @, retry

# everything else is a local name
R$+			$#local $:$1			local names
